=== Examples/RegistrationITKv4/test/CMakeLists.txt ===
set(BASELINE ${ITK_DATA_ROOT}/Baseline/Registration)
set(TEMP ${ITK_BINARY_DIR}/Testing/Temporary)

itk_add_test(
  NAME
  ImageRegistrationHistogramPlotterTest
  COMMAND
  ${ITK_TEST_DRIVER}
  --compareNumberOfPixelsTolerance
  30
  --compareIntensityTolerance
  10
  --compareRadiusTolerance
  10
  --compare
  DATA{${BASELINE}/JointEntropyHistogramAfterRegistration.png,:}
  ${TEMP}/JointEntropyHistogramAfterRegistration.png
  $<TARGET_FILE:ImageRegistrationHistogramPlotter>
  ${ITK_SOURCE_DIR}/Examples/Data/BrainT1SliceBorder20.png
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceShifted13x17y.png
  ${TEMP}/RegisteredImage.png
  0
  ${TEMP}/JointEntropyHistogramPriorToRegistration.png
  ${TEMP}/JointEntropyHistogramAfterRegistration.png
  512)
set_property(
  TEST ImageRegistrationHistogramPlotterTest
  APPEND
  PROPERTY LABELS RUNS_LONG)

itk_add_test(
  NAME
  ImageRegistration1Test1
  COMMAND
  ${ITK_TEST_DRIVER}
  --compare
  DATA{${BASELINE}/ImageRegistration1TestPixelCentered.png}
  ${TEMP}/ImageRegistration1Test1PixelCentered.png
  $<TARGET_FILE:ImageRegistration1>
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceBorder20.png
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceShifted13x17y.png
  ${TEMP}/ImageRegistration1Test1PixelCentered.png
  ${TEMP}/ImageRegistration1DifferenceAfterTest1PixelCentered.png
  ${TEMP}/ImageRegistration1DifferenceBeforeTest1PixelCentered.png)

itk_add_test(
  NAME
  ImageRegistration1Test2
  COMMAND
  ${ITK_TEST_DRIVER}
  --compare
  DATA{${BASELINE}/ImageRegistration1TestPixelCentered.png}
  ${TEMP}/ImageRegistration1Test2PixelCentered.png
  $<TARGET_FILE:ImageRegistration1>
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceBorder20.png
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceShifted13x17y.png
  ${TEMP}/ImageRegistration1Test2PixelCentered.png
  ${TEMP}/ImageRegistration1DifferenceAfterTest2PixelCentered.png
  ${TEMP}/ImageRegistration1DifferenceBeforeTest2PixelCentered.png
  1)

itk_add_test(
  NAME
  ImageRegistration2Test
  COMMAND
  ${ITK_TEST_DRIVER}
  --compare
  DATA{${BASELINE}/ImageRegistration2Test.png}
  ${TEMP}/ImageRegistration2Test.png
  $<TARGET_FILE:ImageRegistration2>
  ${ITK_SOURCE_DIR}/Examples/Data/BrainT1SliceBorder20.png
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceShifted13x17y.png
  ${TEMP}/ImageRegistration2Test.png
  ${TEMP}/ImageRegistration2BeforeTest.png
  ${TEMP}/ImageRegistration2AfterTest.png)
set_property(
  TEST ImageRegistration2Test
  APPEND
  PROPERTY LABELS RUNS_LONG)

itk_add_test(
  NAME
  ImageRegistration3Test
  COMMAND
  ${ITK_TEST_DRIVER}
  --compare
  DATA{${BASELINE}/ImageRegistration3TestPixelCentered.png}
  ${TEMP}/ImageRegistration3TestPixelCentered.png
  $<TARGET_FILE:ImageRegistration3>
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceBorder20.png
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceShifted13x17y.png
  ${TEMP}/ImageRegistration3TestPixelCentered.png)

itk_add_test(
  NAME
  ImageRegistration4Test
  COMMAND
  ${ITK_TEST_DRIVER}
  --compare
  DATA{${BASELINE}/ImageRegistration4Test.png}
  ${TEMP}/ImageRegistration4Test.png
  $<TARGET_FILE:ImageRegistration4>
  ${ITK_SOURCE_DIR}/Examples/Data/BrainT1SliceBorder20.png
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceShifted13x17y.png
  ${TEMP}/ImageRegistration4Test.png
  0
  ${TEMP}/ImageRegistration4BeforeTest.png
  ${TEMP}/ImageRegistration4AfterTest.png
  24)

itk_add_test(
  NAME
  ImageRegistration4Test2
  COMMAND
  ${ITK_TEST_DRIVER}
  $<TARGET_FILE:ImageRegistration4>
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceBorder20Mask.png
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceBorder20Mask.png
  ${TEMP}/ImageRegistration4Test2.png
  0
  ${TEMP}/ImageRegistration4BeforeTest2.png
  ${TEMP}/ImageRegistration4AfterTest2.png
  5)

itk_add_test(
  NAME
  ImageRegistration5Test1
  COMMAND
  ${ITK_TEST_DRIVER}
  --compare
  DATA{${BASELINE}/ImageRegistration5Test1PixelCentered.png}
  ${TEMP}/ImageRegistration5Test1PixelCentered.png
  --compareNumberOfPixelsTolerance
  115
  $<TARGET_FILE:ImageRegistration5>
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceBorder20.png
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceRotated10.png
  ${TEMP}/ImageRegistration5Test1PixelCentered.png)

itk_add_test(
  NAME
  ImageRegistration5Test2
  COMMAND
  ${ITK_TEST_DRIVER}
  --compare
  DATA{${BASELINE}/ImageRegistration5Test2PixelCentered.png}
  ${TEMP}/ImageRegistration5Test2PixelCentered.png
  $<TARGET_FILE:ImageRegistration5>
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceBorder20.png
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceR10X13Y17.png
  ${TEMP}/ImageRegistration5Test2PixelCentered.png
  ${TEMP}/ImageRegistration5Test2DifferenceAfter.png
  ${TEMP}/ImageRegistration5Test2DifferenceBefore.png
  1.3)

itk_add_test(
  NAME
  ImageRegistration6Test
  COMMAND
  ${ITK_TEST_DRIVER}
  --compare
  DATA{${BASELINE}/ImageRegistration6TestPixelCentered.png}
  ${TEMP}/ImageRegistration6TestPixelCentered.png
  --compareNumberOfPixelsTolerance
  100
  $<TARGET_FILE:ImageRegistration6>
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceBorder20.png
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceR10X13Y17.png
  ${TEMP}/ImageRegistration6TestPixelCentered.png)

itk_add_test(
  NAME
  ImageRegistration7Test
  COMMAND
  ${ITK_TEST_DRIVER}
  --compare
  DATA{${BASELINE}/ImageRegistration7TestPixelCentered.png}
  ${TEMP}/ImageRegistration7TestPixelCentered.png
  --compareNumberOfPixelsTolerance
  100
  $<TARGET_FILE:ImageRegistration7>
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceBorder20.png
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceR10X13Y17S12.png
  ${TEMP}/ImageRegistration7TestPixelCentered.png
  ${TEMP}/ImageRegistration7BeforeTestPixelCentered.png
  ${TEMP}/ImageRegistration7AfterTestPixelCentered.png
  1.0
  1.0
  0.0)

if(ITK_USE_BRAINWEB_DATA)

  ## A test needed to prepare for making the latex documentation.
  itk_add_test(
    NAME
    ConfidenceConnected3DTest
    COMMAND
    ${ITK_TEST_DRIVER}
    $<TARGET_FILE:ConfidenceConnected3D>
    DATA{../../Data/BrainWeb/brainweb165a10f17.mha}
    ${TEMP}/WhiteMatterSegmentation.mhd)

  itk_add_test(
    NAME
    ImageRegistration8Test
    COMMAND
    ${ITK_TEST_DRIVER}
    --compare
    DATA{${BASELINE}/ImageRegistration8RegisteredSlice.png}
    ${TEMP}/ImageRegistration8v4RegisteredSlice.png
    $<TARGET_FILE:ImageRegistration8>
    DATA{../../Data/BrainWeb/brainweb1e1a10f20.mha}
    DATA{../../Data/BrainWeb/brainweb1e1a10f20Rot10Tx15.mha}
    ${TEMP}/ImageRegistration8v4Output.mhd
    ${TEMP}/ImageRegistration8v4DifferenceBefore.mhd
    ${TEMP}/ImageRegistration8v4DifferenceAfter.mhd
    ${TEMP}/ImageRegistration8v4Output.png
    ${TEMP}/ImageRegistration8v4DifferenceBefore.png
    ${TEMP}/ImageRegistration8v4DifferenceAfter.png
    ${TEMP}/ImageRegistration8v4RegisteredSlice.png)
  set_property(
    TEST ImageRegistration8Test
    APPEND
    PROPERTY LABELS RUNS_LONG)

  if(${CMAKE_BUILD_TYPE} MATCHES "Release")
    # This test is computationally demanding.
    # Therefore we only run it in a Release build
    itk_add_test(
      NAME
      ImageRegistration20Test
      COMMAND
      ${ITK_TEST_DRIVER}
      $<TARGET_FILE:ImageRegistration20>
      DATA{../../Data/BrainWeb/brainweb1e1a10f20.mha}
      DATA{../../Data/BrainWeb/brainweb1e1a10f20Rot10Tx15.mha}
      ${TEMP}/ImageRegistration20Output.mhd
      ${TEMP}/ImageRegistration20DifferenceBefore.mhd
      ${TEMP}/ImageRegistration20DifferenceAfter.mhd
      0.1 # Step length
      300 # maximum number of iterations
    )
    set_tests_properties(ImageRegistration20Test PROPERTIES RUN_SERIAL 1)
  endif()

endif()

itk_add_test(
  NAME
  ImageRegistration9Test
  COMMAND
  ${ITK_TEST_DRIVER}
  --compare
  DATA{${BASELINE}/ImageRegistration9TestPixelCentered.png}
  ${TEMP}/ImageRegistration9TestPixelCentered.png
  --compareNumberOfPixelsTolerance
  50
  $<TARGET_FILE:ImageRegistration9>
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceBorder20.png
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceR10X13Y17.png
  ${TEMP}/ImageRegistration9TestPixelCentered.png)

itk_add_test(
  NAME
  ImageRegistration10Test
  COMMAND
  ${ITK_TEST_DRIVER}
  --compare
  DATA{${BASELINE}/ImageRegistration10TestPixelCentered.png,:}
  ${TEMP}/ImageRegistration10TestPixelCentered.png
  $<TARGET_FILE:ImageRegistration10>
  DATA{${ITK_SOURCE_DIR}/Testing/Data/Baseline/Segmentation/WatershedSegmentation1Test1.png}
  DATA{${ITK_SOURCE_DIR}/Testing/Data/Baseline/Segmentation/WatershedSegmentation1Test2.png}
  ${TEMP}/ImageRegistration10TestPixelCentered.png
  ${TEMP}/ImageRegistration10DifferenceTestPixelCentered.png
  -11
  -13)

itk_add_test(
  NAME
  ImageRegistration13Test
  COMMAND
  ${ITK_TEST_DRIVER}
  --compare
  DATA{${BASELINE}/ImageRegistration13TestPixelCentered.png}
  ${TEMP}/ImageRegistration13TestPixelCentered.png
  --compareNumberOfPixelsTolerance
  35
  $<TARGET_FILE:ImageRegistration13>
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceBorder20.png
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceR10X13Y17.png
  ${TEMP}/ImageRegistration13TestPixelCentered.png)

itk_add_test(
  NAME
  ImageRegistration14Test
  COMMAND
  ${ITK_TEST_DRIVER}
  --compare
  DATA{${BASELINE}/ImageRegistration14Test.png,:}
  ${TEMP}/ImageRegistration14Test.png
  --compareNumberOfPixelsTolerance
  2000
  $<TARGET_FILE:ImageRegistration14>
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceBorder20.png
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceR10X13Y17.png
  ${TEMP}/ImageRegistration14Test.png
  32
  0.01
  0.1
  0.15
  10.0
  14.0)
set_property(
  TEST ImageRegistration14Test
  APPEND
  PROPERTY LABELS RUNS_LONG)

itk_add_test(
  NAME
  ImageRegistration15Test
  COMMAND
  ${ITK_TEST_DRIVER}
  --compare
  DATA{${BASELINE}/ImageRegistration15TestPixelCentered.png}
  ${TEMP}/ImageRegistration15TestPixelCentered.png
  $<TARGET_FILE:ImageRegistration15>
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceBorder20.png
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceShifted13x17y.png
  ${TEMP}/ImageRegistration15TestPixelCentered.png
  32
  0.1
  0.05
  0.0
  0.0)
set_property(
  TEST ImageRegistration15Test
  APPEND
  PROPERTY LABELS RUNS_LONG)

itk_add_test(
  NAME
  ImageRegistration16Test
  COMMAND
  ${ITK_TEST_DRIVER}
  --compare
  DATA{${BASELINE}/ImageRegistration16TestPixelCentered.png}
  ${TEMP}/ImageRegistration16TestPixelCentered.png
  $<TARGET_FILE:ImageRegistration16>
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceBorder20.png
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceShifted13x17y.png
  ${TEMP}/ImageRegistration16TestPixelCentered.png
  0.0
  0.0)

itk_add_test(
  NAME
  ImageRegistration16Test2
  COMMAND
  ${ITK_TEST_DRIVER}
  --compare
  DATA{${BASELINE}/ImageRegistration16TestPixelCentered.png}
  ${TEMP}/ImageRegistration16Test2PixelCentered.png
  $<TARGET_FILE:ImageRegistration16>
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceBorder20.png
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceShifted13x17y.png
  ${TEMP}/ImageRegistration16Test2PixelCentered.png
  0.0
  0.0
  0)

itk_add_test(
  NAME
  ImageRegistration17Test
  COMMAND
  ${ITK_TEST_DRIVER}
  --compare
  DATA{${BASELINE}/ImageRegistration17TestPixelCentered.png,:}
  ${TEMP}/ImageRegistration17TestPixelCentered.png
  --compareNumberOfPixelsTolerance
  5
  $<TARGET_FILE:ImageRegistration17>
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceBorder20.png
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceShifted13x17y.png
  ${TEMP}/ImageRegistration17TestPixelCentered.png
  0.0
  0.0)

itk_add_test(
  NAME
  ImageRegistration18Test
  COMMAND
  ImageRegistration18
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceBorder20.png
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceShifted13x17y.png
