=== Modules/Filtering/MathematicalMorphology/CMakeLists.txt ===
project(ITKMathematicalMorphology)
set(ITKMathematicalMorphology_LIBRARIES ITKMathematicalMorphology)
itk_module_impl()
