=== Modules/Registration/Common/CMakeLists.txt ===
project(ITKRegistrationCommon)
itk_module_impl()
