=== Modules/Filtering/ImageStatistics/wrapping/CMakeLists.txt ===
itk_wrap_module(ITKImageStatistics)
itk_auto_load_and_end_wrap_submodules()
