=== debian/changelog ===
insighttoolkit5 (5.4.3-5) unstable; urgency=medium

  * Team upload.
  * Make itkOptImageToImageMetricsTest04 not to fail on single-CPU systems.
    Closes: #1105896.
  * Update standards-version.

 -- Santiago Vila <sanvila@debian.org>  Thu, 22 May 2025 00:40:00 +0200

insighttoolkit5 (5.4.3-4) unstable; urgency=medium

  [ Steve Robbins ]
  * [1af5def] FFTW configuration needs itk configuration include.

 -- Steve M. Robbins <smr@debian.org>  Mon, 21 Apr 2025 23:48:27 -0500

insighttoolkit5 (5.4.3-3) unstable; urgency=medium

  * Release to unstable.

 -- Steve M. Robbins <smr@debian.org>  Sat, 19 Apr 2025 21:13:19 -0500

insighttoolkit5 (5.4.3-2) experimental; urgency=medium

  [ Steve Robbins ]
  * [00367e9] Fix build with gcc-15.  Closes: #1096841.

 -- Steve M. Robbins <smr@debian.org>  Fri, 18 Apr 2025 14:52:31 -0500

insighttoolkit5 (5.4.3-1) experimental; urgency=medium

  [ Steve Robbins ]
  * [72aaa69] Update import notes
  * [3bfd67a] New upstream version 5.4.3

 -- Steve M. Robbins <smr@debian.org>  Sun, 06 Apr 2025 13:03:40 -0500
